searchData={"items":[{"type":"module","doc":"Minimal HTTP ClickHouse client.","title":"Ch","ref":"Ch.html"},{"type":"function","doc":"Returns a supervisor child specification for a DBConnection pool.\n\nSee `start_link/1` for supported options.","title":"Ch.child_spec/1","ref":"Ch.html#child_spec/1"},{"type":"type","doc":"","title":"Ch.common_option/0","ref":"Ch.html#t:common_option/0"},{"type":"function","doc":"Runs a query and returns the result as `{:ok, %Ch.Result{}}` or\n`{:error, Exception.t()}` if there was a database error.","title":"Ch.query/4","ref":"Ch.html#query/4"},{"type":"function","doc":"* `:database` - Database\n  * `:username` - Username\n  * `:password` - User password\n  * `:settings` - Keyword list of settings\n  * `:timeout` - Query request timeout\n  * `:command` - Command tag for the query\n  * `:headers` - Custom HTTP headers for the request\n  * `:format` - Custom response format for the request\n  * `:decode` - Whether to automatically decode the response\n  * [`DBConnection.connection_option()`](https://hexdocs.pm/db_connection/DBConnection.html#t:connection_option/0)","title":"Options - Ch.query/4","ref":"Ch.html#query/4-options"},{"type":"function","doc":"Runs a query and returns the result or raises `Ch.Error` if\nthere was an error. See `query/4`.","title":"Ch.query!/4","ref":"Ch.html#query!/4"},{"type":"type","doc":"","title":"Ch.query_option/0","ref":"Ch.html#t:query_option/0"},{"type":"function","doc":"Start the connection process and connect to ClickHouse.","title":"Ch.start_link/1","ref":"Ch.html#start_link/1"},{"type":"function","doc":"* `:scheme` - HTTP scheme, defaults to `\"http\"`\n  * `:hostname` - server hostname, defaults to `\"localhost\"`\n  * `:port` - HTTP port, defaults to `8123`\n  * `:transport_opts` - options to be given to the transport being used. See `Mint.HTTP1.connect/4` for more info\n  * `:database` - Database, defaults to `\"default\"`\n  * `:username` - Username\n  * `:password` - User password\n  * `:settings` - Keyword list of ClickHouse settings\n  * `:timeout` - HTTP receive timeout in milliseconds\n  * `:transport_opts` - options to be given to the transport being used. See `Mint.HTTP1.connect/4` for more info\n  * [`DBConnection.start_option()`](https://hexdocs.pm/db_connection/DBConnection.html#t:start_option/0)","title":"Options - Ch.start_link/1","ref":"Ch.html#start_link/1-options"},{"type":"type","doc":"","title":"Ch.start_option/0","ref":"Ch.html#t:start_option/0"},{"type":"module","doc":"Query struct wrapping the SQL statement.","title":"Ch.Query","ref":"Ch.Query.html"},{"type":"type","doc":"","title":"Ch.Query.command/0","ref":"Ch.Query.html#t:command/0"},{"type":"type","doc":"","title":"Ch.Query.t/0","ref":"Ch.Query.html#t:t/0"},{"type":"module","doc":"Result struct returned from any successful query. Its fields are:\n\n  * `command` - An atom of the query command, for example: `:select`, `:insert`\n  * `columns` - A list of column names\n  * `rows` - A list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column\n  * `num_rows` - The number of fetched or affected rows\n  * `headers` - The HTTP response headers\n  * `data` - The raw iodata from the response","title":"Ch.Result","ref":"Ch.Result.html"},{"type":"type","doc":"","title":"Ch.Result.t/0","ref":"Ch.Result.html#t:t/0"},{"type":"module","doc":"Helpers for working with ClickHouse [RowBinary](https://clickhouse.com/docs/en/interfaces/formats/RowBinary) format.","title":"Ch.RowBinary","ref":"Ch.RowBinary.html"},{"type":"function","doc":"Same as `decode_rows/1` but the first element is a list of column names.\n\nExample:\n\n    iex> decode_names_and_rows(<<1, 3, \"1+1\"::bytes, 5, \"UInt8\"::bytes, 2>>)\n    [[\"1+1\"], [2]]","title":"Ch.RowBinary.decode_names_and_rows/1","ref":"Ch.RowBinary.html#decode_names_and_rows/1"},{"type":"function","doc":"Decodes [RowBinaryWithNamesAndTypes](https://clickhouse.com/docs/en/interfaces/formats/RowBinaryWithNamesAndTypes) into rows.\n\nExample:\n\n    iex> decode_rows(<<1, 3, \"1+1\"::bytes, 5, \"UInt8\"::bytes, 2>>)\n    [[2]]","title":"Ch.RowBinary.decode_rows/1","ref":"Ch.RowBinary.html#decode_rows/1"},{"type":"function","doc":"Decodes [RowBinary](https://clickhouse.com/docs/en/interfaces/formats/RowBinary) into rows.\n\nExample:\n\n    iex> decode_rows(<<1>>, [\"UInt8\"])\n    [[1]]","title":"Ch.RowBinary.decode_rows/2","ref":"Ch.RowBinary.html#decode_rows/2"},{"type":"function","doc":"Encodes a single row to [RowBinary](https://clickhouse.com/docs/en/interfaces/formats/RowBinary) as iodata.\n\nExamples:\n\n    iex> encode_row([], [])\n    []\n\n    iex> encode_row([1], [\"UInt8\"])\n    [1]\n\n    iex> encode_row([3, \"hello\"], [\"UInt8\", \"String\"])\n    [3, [5 | \"hello\"]]","title":"Ch.RowBinary.encode_row/2","ref":"Ch.RowBinary.html#encode_row/2"},{"type":"function","doc":"Encodes multiple rows to [RowBinary](https://clickhouse.com/docs/en/interfaces/formats/RowBinary) as iodata.\n\nExamples:\n\n    iex> encode_rows([], [])\n    []\n\n    iex> encode_rows([[1]], [\"UInt8\"])\n    [1]\n\n    iex> encode_rows([[3, \"hello\"], [4, \"hi\"]], [\"UInt8\", \"String\"])\n    [3, [5 | \"hello\"], 4, [2 | \"hi\"]]","title":"Ch.RowBinary.encode_rows/2","ref":"Ch.RowBinary.html#encode_rows/2"},{"type":"module","doc":"Helpers to turn ClickHouse types into Elixir terms for easier processing.","title":"Ch.Types","ref":"Ch.Types.html"},{"type":"function","doc":"Helper for `Array(T)` ClickHouse type:\n\n    iex> array(u64())\n    {:array, :u64}\n\n    iex> to_string(encode(array(u64())))\n    \"Array(UInt64)\"\n\n    iex> decode(\"Array(UInt64)\")\n    array(u64())","title":"Ch.Types.array/1","ref":"Ch.Types.html#array/1"},{"type":"function","doc":"Helper for `Bool` ClickHouse type:\n\n    iex> boolean()\n    :boolean\n\n    iex> encode(boolean())\n    \"Bool\"\n\n    iex> decode(\"Bool\")\n    boolean()","title":"Ch.Types.boolean/0","ref":"Ch.Types.html#boolean/0"},{"type":"function","doc":"Helper for `Date32` ClickHouse type:\n\n    iex> date32()\n    :date32\n\n    iex> encode(date32())\n    \"Date32\"\n\n    iex> decode(\"Date32\")\n    date32()","title":"Ch.Types.date32/0","ref":"Ch.Types.html#date32/0"},{"type":"function","doc":"Helper for `Date` ClickHouse type:\n\n    iex> date()\n    :date\n\n    iex> encode(date())\n    \"Date\"\n\n    iex> decode(\"Date\")\n    date()","title":"Ch.Types.date/0","ref":"Ch.Types.html#date/0"},{"type":"function","doc":"Helper for `DateTime64(precision)` ClickHouse type:\n\n    iex> datetime64(3)\n    {:datetime64, 3}\n\n    iex> to_string(encode(datetime64(3)))\n    \"DateTime64(3)\"\n\n    iex> decode(\"DateTime64(3)\")\n    datetime64(3)","title":"Ch.Types.datetime64/1","ref":"Ch.Types.html#datetime64/1"},{"type":"function","doc":"Helper for `DateTime64(precision, timezone)` ClickHouse type:\n\n    iex> datetime64(3, \"UTC\")\n    {:datetime64, 3, \"UTC\"}\n\n    iex> to_string(encode(datetime64(3, \"UTC\")))\n    \"DateTime64(3, 'UTC')\"\n\n    iex> decode(\"DateTime64(3, 'UTC')\")\n    datetime64(3, \"UTC\")","title":"Ch.Types.datetime64/2","ref":"Ch.Types.html#datetime64/2"},{"type":"function","doc":"Helper for `DateTime` ClickHouse type:\n\n    iex> datetime()\n    :datetime\n\n    iex> to_string(encode(datetime()))\n    \"DateTime\"\n\n    iex> decode(\"DateTime\")\n    datetime()","title":"Ch.Types.datetime/0","ref":"Ch.Types.html#datetime/0"},{"type":"function","doc":"Helper for `DateTime(timezone)` ClickHouse type:\n\n    iex> datetime(\"Europe/Vienna\")\n    {:datetime, \"Europe/Vienna\"}\n\n    iex> to_string(encode(datetime(\"UTC\")))\n    \"DateTime('UTC')\"\n\n    iex> decode(\"DateTime('UTC')\")\n    datetime(\"UTC\")","title":"Ch.Types.datetime/1","ref":"Ch.Types.html#datetime/1"},{"type":"function","doc":"Helper for `Decimal32(S)` ClickHouse type:\n\n    iex> decimal32(4)\n    {:decimal32, 4}\n\n    iex> to_string(encode(decimal32(4)))\n    \"Decimal(9, 4)\"\n\n    iex> decode(\"Decimal32(4)\")\n    {:decimal32, 4}","title":"Ch.Types.decimal32/1","ref":"Ch.Types.html#decimal32/1"},{"type":"function","doc":"Helper for `Decimal64(S)` ClickHouse type:\n\n    iex> decimal64(4)\n    {:decimal64, 4}\n\n    iex> to_string(encode(decimal64(4)))\n    \"Decimal(18, 4)\"\n\n    iex> decode(\"Decimal64(4)\")\n    {:decimal64, 4}","title":"Ch.Types.decimal64/1","ref":"Ch.Types.html#decimal64/1"},{"type":"function","doc":"Helper for `Decimal128(S)` ClickHouse type:\n\n    iex> decimal128(4)\n    {:decimal128, 4}\n\n    iex> to_string(encode(decimal128(4)))\n    \"Decimal(38, 4)\"\n\n    iex> decode(\"Decimal128(4)\")\n    {:decimal128, 4}","title":"Ch.Types.decimal128/1","ref":"Ch.Types.html#decimal128/1"},{"type":"function","doc":"Helper for `Decimal256(S)` ClickHouse type:\n\n    iex> decimal256(4)\n    {:decimal256, 4}\n\n    iex> to_string(encode(decimal256(4)))\n    \"Decimal(76, 4)\"\n\n    iex> decode(\"Decimal256(4)\")\n    {:decimal256, 4}","title":"Ch.Types.decimal256/1","ref":"Ch.Types.html#decimal256/1"},{"type":"function","doc":"Helper for `Decimal(P, S)` ClickHouse type:\n\n    iex> decimal(18, 4)\n    {:decimal, 18, 4}\n\n    iex> to_string(encode(decimal(18, 4)))\n    \"Decimal(18, 4)\"\n\n    iex> decode(\"Decimal(18, 4)\")\n    decimal(18, 4)","title":"Ch.Types.decimal/2","ref":"Ch.Types.html#decimal/2"},{"type":"function","doc":"Decodes a ClickHouse type into an intermediary Elixir term.\n\n    iex> decode(\"String\")\n    :string\n\n    iex> decode(\"Array(String)\")\n    {:array, :string}\n\n    iex> decode(\"Enum8('hello' = 1, 'world' = 2)\")\n    {:enum8, [{\"hello\", 1}, {\"world\", 2}]}\n\n    iex> decode(\"Nullable(Decimal(18, 4))\")\n    {:nullable, {:decimal, 18, 4}}","title":"Ch.Types.decode/1","ref":"Ch.Types.html#decode/1"},{"type":"function","doc":"Encodes a type from Elixir atom / tuple to proper ClickHouse name.\n\n    iex> encode(:string)\n    \"String\"\n\n    iex> IO.iodata_to_binary(encode({:nullable, :i8}))\n    \"Nullable(Int8)\"","title":"Ch.Types.encode/1","ref":"Ch.Types.html#encode/1"},{"type":"function","doc":"Helper for `Enum8` ClickHouse type:\n\n    iex> enum8([{\"hello\", 1}, {\"world\", 2}])\n    {:enum8, [{\"hello\", 1}, {\"world\", 2}]}\n\n    iex> to_string(encode(enum8([{\"hello\", 1}, {\"world\", 2}])))\n    \"Enum8('hello' = 1, 'world' = 2)\"\n\n    iex> decode(\"Enum8('hello' = 1, 'world' = 2)\")\n    enum8([{\"hello\", 1}, {\"world\", 2}])","title":"Ch.Types.enum8/1","ref":"Ch.Types.html#enum8/1"},{"type":"function","doc":"Helper for `Enum16` ClickHouse type:\n\n    iex> enum16([{\"hello\", 1}, {\"world\", 2}])\n    {:enum16, [{\"hello\", 1}, {\"world\", 2}]}\n\n    iex> to_string(encode(enum16([{\"hello\", 1}, {\"world\", 2}])))\n    \"Enum16('hello' = 1, 'world' = 2)\"\n\n    iex> decode(\"Enum16('hello' = 1, 'world' = 2)\")\n    enum16([{\"hello\", 1}, {\"world\", 2}])","title":"Ch.Types.enum16/1","ref":"Ch.Types.html#enum16/1"},{"type":"function","doc":"Helper for `Float32` ClickHouse type:\n\n    iex> f32()\n    :f32\n\n    iex> encode(f32())\n    \"Float32\"\n\n    iex> decode(\"Float32\")\n    f32()","title":"Ch.Types.f32/0","ref":"Ch.Types.html#f32/0"},{"type":"function","doc":"Helper for `Float64` ClickHouse type:\n\n    iex> f64()\n    :f64\n\n    iex> encode(f64())\n    \"Float64\"\n\n    iex> decode(\"Float64\")\n    f64()","title":"Ch.Types.f64/0","ref":"Ch.Types.html#f64/0"},{"type":"function","doc":"Helper for `FixedString(n)` ClickHouse type:\n\n    iex> fixed_string(3)\n    {:fixed_string, 3}\n\n    iex> to_string(encode(fixed_string(16)))\n    \"FixedString(16)\"\n\n    iex> decode(\"FixedString(16)\")\n    fixed_string(16)","title":"Ch.Types.fixed_string/1","ref":"Ch.Types.html#fixed_string/1"},{"type":"function","doc":"Helper for `Int8` ClickHouse type:\n\n    iex> i8()\n    :i8\n\n    iex> encode(i8())\n    \"Int8\"\n\n    iex> decode(\"Int8\")\n    i8()","title":"Ch.Types.i8/0","ref":"Ch.Types.html#i8/0"},{"type":"function","doc":"Helper for `Int16` ClickHouse type:\n\n    iex> i16()\n    :i16\n\n    iex> encode(i16())\n    \"Int16\"\n\n    iex> decode(\"Int16\")\n    i16()","title":"Ch.Types.i16/0","ref":"Ch.Types.html#i16/0"},{"type":"function","doc":"Helper for `Int32` ClickHouse type:\n\n    iex> i32()\n    :i32\n\n    iex> encode(i32())\n    \"Int32\"\n\n    iex> decode(\"Int32\")\n    i32()","title":"Ch.Types.i32/0","ref":"Ch.Types.html#i32/0"},{"type":"function","doc":"Helper for `Int64` ClickHouse type:\n\n    iex> i64()\n    :i64\n\n    iex> encode(i64())\n    \"Int64\"\n\n    iex> decode(\"Int64\")\n    i64()","title":"Ch.Types.i64/0","ref":"Ch.Types.html#i64/0"},{"type":"function","doc":"Helper for `Int128` ClickHouse type:\n\n    iex> i128()\n    :i128\n\n    iex> encode(i128())\n    \"Int128\"\n\n    iex> decode(\"Int128\")\n    i128()","title":"Ch.Types.i128/0","ref":"Ch.Types.html#i128/0"},{"type":"function","doc":"Helper for `Int256` ClickHouse type:\n\n    iex> i256()\n    :i256\n\n    iex> encode(i256())\n    \"Int256\"\n\n    iex> decode(\"Int256\")\n    i256()","title":"Ch.Types.i256/0","ref":"Ch.Types.html#i256/0"},{"type":"function","doc":"Helper for `IPv4` ClickHouse type:\n\n    iex> ipv4()\n    :ipv4\n\n    iex> encode(ipv4())\n    \"IPv4\"\n\n    iex> decode(\"IPv4\")\n    ipv4()","title":"Ch.Types.ipv4/0","ref":"Ch.Types.html#ipv4/0"},{"type":"function","doc":"Helper for `IPv6` ClickHouse type:\n\n    iex> ipv6()\n    :ipv6\n\n    iex> encode(ipv6())\n    \"IPv6\"\n\n    iex> decode(\"IPv6\")\n    ipv6()","title":"Ch.Types.ipv6/0","ref":"Ch.Types.html#ipv6/0"},{"type":"function","doc":"Helper for `LowCardinality(T)` ClickHouse type:\n\n    iex> low_cardinality(string())\n    {:low_cardinality, :string}\n\n    iex> to_string(encode(low_cardinality(string())))\n    \"LowCardinality(String)\"\n\n    iex> decode(\"LowCardinality(String)\")\n    low_cardinality(string())","title":"Ch.Types.low_cardinality/1","ref":"Ch.Types.html#low_cardinality/1"},{"type":"function","doc":"Helper for `Map(K, V)` ClickHouse type:\n\n    iex> map(string(), array(string()))\n    {:map, :string, {:array, :string}}\n\n    iex> to_string(encode(map(string(), array(string()))))\n    \"Map(String, Array(String))\"\n\n    iex> decode(\"Map(String, Array(String))\")\n    map(string(), array(string()))","title":"Ch.Types.map/2","ref":"Ch.Types.html#map/2"},{"type":"function","doc":"Helper for `MultiPolygon` ClickHouse type:\n\n    iex> multipolygon()\n    :multipolygon\n\n    iex> encode(multipolygon())\n    \"MultiPolygon\"\n\n    iex> decode(\"MultiPolygon\")\n    multipolygon()","title":"Ch.Types.multipolygon/0","ref":"Ch.Types.html#multipolygon/0"},{"type":"function","doc":"Helper for `Nothing` ClickHouse type:\n\n    iex> nothing()\n    :nothing\n\n    iex> encode(nothing())\n    \"Nothing\"\n\n    iex> decode(\"Nothing\")\n    nothing()","title":"Ch.Types.nothing/0","ref":"Ch.Types.html#nothing/0"},{"type":"function","doc":"Helper for `Nullable(T)` ClickHouse type:\n\n    iex> nullable(array(boolean()))\n    {:nullable, {:array, :boolean}}\n\n    iex> to_string(encode(nullable(array(boolean()))))\n    \"Nullable(Array(Bool))\"\n\n    iex> decode(\"Nullable(Array(Bool))\")\n    nullable(array(boolean()))","title":"Ch.Types.nullable/1","ref":"Ch.Types.html#nullable/1"},{"type":"function","doc":"Helper for `Point` ClickHouse type:\n\n    iex> point()\n    :point\n\n    iex> encode(point())\n    \"Point\"\n\n    iex> decode(\"Point\")\n    point()","title":"Ch.Types.point/0","ref":"Ch.Types.html#point/0"},{"type":"function","doc":"Helper for `Polygon` ClickHouse type:\n\n    iex> polygon()\n    :polygon\n\n    iex> encode(polygon())\n    \"Polygon\"\n\n    iex> decode(\"Polygon\")\n    polygon()","title":"Ch.Types.polygon/0","ref":"Ch.Types.html#polygon/0"},{"type":"function","doc":"Helper for `Ring` ClickHouse type:\n\n    iex> ring()\n    :ring\n\n    iex> encode(ring())\n    \"Ring\"\n\n    iex> decode(\"Ring\")\n    ring()","title":"Ch.Types.ring/0","ref":"Ch.Types.html#ring/0"},{"type":"function","doc":"Helper for `SimpleAggregateFunction(name, type)` ClickHouse type:\n\n    iex> simple_aggregate_function(\"any\", u8())\n    {:simple_aggregate_function, \"any\", :u8}\n\n    iex> to_string(encode(simple_aggregate_function(\"any\", u8())))\n    \"SimpleAggregateFunction(any, UInt8)\"\n\n    iex> decode(\"SimpleAggregateFunction(any, UInt8)\")\n    simple_aggregate_function(\"any\", u8())","title":"Ch.Types.simple_aggregate_function/2","ref":"Ch.Types.html#simple_aggregate_function/2"},{"type":"function","doc":"Helper for `String` ClickHouse type:\n\n    iex> string()\n    :string\n\n    iex> encode(string())\n    \"String\"\n\n    iex> decode(\"String\")\n    string()","title":"Ch.Types.string/0","ref":"Ch.Types.html#string/0"},{"type":"function","doc":"Helper for `Tuple(T1, T2, ...)` ClickHouse type:\n\n    iex> tuple([u64(), array(string())])\n    {:tuple, [:u64, {:array, :string}]}\n\n    iex> to_string(encode(tuple([u64(), array(string())])))\n    \"Tuple(UInt64, Array(String))\"\n\n    iex> decode(\"Tuple(UInt64, Array(String))\")\n    tuple([u64(), array(string())])","title":"Ch.Types.tuple/1","ref":"Ch.Types.html#tuple/1"},{"type":"function","doc":"Helper for `UInt8` ClickHouse type:\n\n    iex> u8()\n    :u8\n\n    iex> encode(u8())\n    \"UInt8\"\n\n    iex> decode(\"UInt8\")\n    u8()","title":"Ch.Types.u8/0","ref":"Ch.Types.html#u8/0"},{"type":"function","doc":"Helper for `UInt16` ClickHouse type:\n\n    iex> u16()\n    :u16\n\n    iex> encode(u16())\n    \"UInt16\"\n\n    iex> decode(\"UInt16\")\n    u16()","title":"Ch.Types.u16/0","ref":"Ch.Types.html#u16/0"},{"type":"function","doc":"Helper for `UInt32` ClickHouse type:\n\n    iex> u32()\n    :u32\n\n    iex> encode(u32())\n    \"UInt32\"\n\n    iex> decode(\"UInt32\")\n    u32()","title":"Ch.Types.u32/0","ref":"Ch.Types.html#u32/0"},{"type":"function","doc":"Helper for `UInt64` ClickHouse type:\n\n    iex> u64()\n    :u64\n\n    iex> encode(u64())\n    \"UInt64\"\n\n    iex> decode(\"UInt64\")\n    u64()","title":"Ch.Types.u64/0","ref":"Ch.Types.html#u64/0"},{"type":"function","doc":"Helper for `UInt128` ClickHouse type:\n\n    iex> u128()\n    :u128\n\n    iex> encode(u128())\n    \"UInt128\"\n\n    iex> decode(\"UInt128\")\n    u128()","title":"Ch.Types.u128/0","ref":"Ch.Types.html#u128/0"},{"type":"function","doc":"Helper for `UInt256` ClickHouse type:\n\n    iex> u256()\n    :u256\n\n    iex> encode(u256())\n    \"UInt256\"\n\n    iex> decode(\"UInt256\")\n    u256()","title":"Ch.Types.u256/0","ref":"Ch.Types.html#u256/0"},{"type":"function","doc":"Helper for `UUID` ClickHouse type:\n\n    iex> uuid()\n    :uuid\n\n    iex> encode(uuid())\n    \"UUID\"\n\n    iex> decode(\"UUID\")\n    uuid()","title":"Ch.Types.uuid/0","ref":"Ch.Types.html#uuid/0"},{"type":"exception","doc":"Error struct wrapping ClickHouse error responses.","title":"Ch.Error","ref":"Ch.Error.html"},{"type":"type","doc":"","title":"Ch.Error.t/0","ref":"Ch.Error.html#t:t/0"},{"type":"extras","doc":"# Ch\n\n[![Documentation badge](https://img.shields.io/badge/Documentation-ff69b4)](https://hexdocs.pm/ch)\n[![Hex.pm badge](https://img.shields.io/badge/Package%20on%20hex.pm-informational)](https://hex.pm/packages/ch)\n\nMinimal HTTP [ClickHouse](https://clickhouse.com) client for Elixir.\n\nUsed in [Ecto ClickHouse adapter.](https://github.com/plausible/ecto_ch)","title":"Ch","ref":"readme.html"},{"type":"extras","doc":"- RowBinary\n- Native query parameters\n- Per query settings\n- Minimal API\n\nYour ideas are welcome [here.](https://github.com/plausible/ch/issues/82)","title":"Key features - Ch","ref":"readme.html#key-features"},{"type":"extras","doc":"```elixir\ndefp deps do\n  [\n    {:ch, \"~> 0.4.0\"}\n  ]\nend\n```","title":"Installation - Ch","ref":"readme.html#installation"},{"type":"extras","doc":"#### Start [DBConnection](https://github.com/elixir-ecto/db_connection) pool\n\n```elixir\ndefaults = [\n  scheme: \"http\",\n  hostname: \"localhost\",\n  port: 8123,\n  database: \"default\",\n  settings: [],\n  pool_size: 1,\n  timeout: :timer.seconds(15)\n]\n\n# note that starting in ClickHouse 25.1.3.23 `default` user doesn't have\n# network access by default in the official Docker images\n# see https://github.com/ClickHouse/ClickHouse/pull/75259\n{:ok, pid} = Ch.start_link(defaults)\n```\n\n#### Select rows\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\n{:ok, %Ch.Result{rows: [[0], [1], [2]]}} =\n  Ch.query(pid, \"SELECT * FROM system.numbers LIMIT 3\")\n\n{:ok, %Ch.Result{rows: [[0], [1], [2]]}} =\n  Ch.query(pid, \"SELECT * FROM system.numbers LIMIT {$0:UInt8}\", [3])\n\n{:ok, %Ch.Result{rows: [[0], [1], [2]]}} =\n  Ch.query(pid, \"SELECT * FROM system.numbers LIMIT {limit:UInt8}\", %{\"limit\" => 3})\n```\n\nNote on datetime encoding in query parameters:\n\n- `%NaiveDateTime{}` is encoded as text to make it assume the column's or ClickHouse server's timezone\n- `%DateTime{}` is encoded as unix timestamp and is treated as UTC timestamp by ClickHouse\n\n#### Insert rows\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null\")\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) VALUES (0), (1)\")\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) VALUES ({$0:UInt8}), ({$1:UInt32})\", [0, 1])\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) VALUES ({a:UInt16}), ({b:UInt64})\", %{\"a\" => 0, \"b\" => 1})\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) SELECT number FROM system.numbers LIMIT {limit:UInt8}\", %{\"limit\" => 2})\n```\n\n#### Insert rows as [RowBinary](https://clickhouse.com/docs/en/interfaces/formats/RowBinary) (efficient)\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null\")\n\ntypes = [\"UInt64\"]\n# or\ntypes = [Ch.Types.u64()]\n# or\ntypes = [:u64]\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) FORMAT RowBinary\", [[0], [1]], types: types)\n```\n\nNote that RowBinary format encoding requires `:types` option to be provided.\n\nSimilarly, you can use [RowBinaryWithNamesAndTypes](https://clickhouse.com/docs/en/interfaces/formats/RowBinaryWithNamesAndTypes) which would additionally do something like a type check.\n\n```elixir\nsql = \"INSERT INTO ch_demo FORMAT RowBinaryWithNamesAndTypes\"\nopts = [names: [\"id\"], types: [\"UInt64\"]]\nrows = [[0], [1]]\n\n%Ch.Result{num_rows: 2} = Ch.query!(pid, sql, rows, opts)\n```\n\n#### Insert rows in custom [format](https://clickhouse.com/docs/en/interfaces/formats)\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null\")\n\ncsv = [0, 1] |> Enum.map(&to_string/1) |> Enum.intersperse(?\\n)\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) FORMAT CSV\", csv, encode: false)\n```\n\n#### Insert rows as chunked RowBinary stream\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null\")\n\nstream = Stream.repeatedly(fn -> [:rand.uniform(100)] end)\nchunked = Stream.chunk_every(stream, 100)\nencoded = Stream.map(chunked, fn chunk -> Ch.RowBinary.encode_rows(chunk, _types = [\"UInt64\"]) end)\nten_encoded_chunks = Stream.take(encoded, 10)\n\n%Ch.Result{num_rows: 1000} =\n  Ch.query(pid, \"INSERT INTO ch_demo(id) FORMAT RowBinary\", ten_encoded_chunks, encode: false)\n```\n\nThis query makes a [`transfer-encoding: chunked`](https://en.wikipedia.org/wiki/Chunked_transfer_encoding) HTTP request while unfolding the stream resulting in lower memory usage.\n\n#### Query with custom [settings](https://clickhouse.com/docs/en/operations/settings/settings)\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nsettings = [async_insert: 1]\n\n%Ch.Result{rows: [[\"async_insert\", \"Bool\", \"0\"]]} =\n  Ch.query!(pid, \"SHOW SETTINGS LIKE 'async_insert'\")\n\n%Ch.Result{rows: [[\"async_insert\", \"Bool\", \"1\"]]} =\n  Ch.query!(pid, \"SHOW SETTINGS LIKE 'async_insert'\", [], settings: settings)\n```","title":"Usage - Ch","ref":"readme.html#usage"},{"type":"extras","doc":"#### NULL in RowBinary\n\nIt's the same as in [ch-go](https://clickhouse.com/docs/en/integrations/go#nullable)\n\n> At insert time, Nil can be passed for both the normal and Nullable version of a column. For the former, the default value for the type will be persisted, e.g., an empty string for string. For the nullable version, a NULL value will be stored in ClickHouse.\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"\"\"\nCREATE TABLE ch_nulls (\n  a UInt8 NULL,\n  b UInt8 DEFAULT 10,\n  c UInt8 NOT NULL\n) ENGINE Memory\n\"\"\")\n\ntypes = [\"Nullable(UInt8)\", \"UInt8\", \"UInt8\"]\ninserted_rows = [[nil, nil, nil]]\nselected_rows = [[nil, 0, 0]]\n\n%Ch.Result{num_rows: 1} =\n  Ch.query!(pid, \"INSERT INTO ch_nulls(a, b, c) FORMAT RowBinary\", inserted_rows, types: types)\n\n%Ch.Result{rows: ^selected_rows} =\n  Ch.query!(pid, \"SELECT * FROM ch_nulls\")\n```\n\nNote that in this example `DEFAULT 10` is ignored and `0` (the default value for `UInt8`) is persisted instead.\n\nHowever, [`input()`](https://clickhouse.com/docs/en/sql-reference/table-functions/input) can be used as a workaround:\n\n```elixir\nsql = \"\"\"\nINSERT INTO ch_nulls\n  SELECT * FROM input('a Nullable(UInt8), b Nullable(UInt8), c UInt8')\n  FORMAT RowBinary\\\n\"\"\"\n\nCh.query!(pid, sql, inserted_rows, types: [\"Nullable(UInt8)\", \"Nullable(UInt8)\", \"UInt8\"])\n\n%Ch.Result{rows: [[0], [10]]} =\n  Ch.query!(pid, \"SELECT b FROM ch_nulls ORDER BY b\")\n```\n\n#### UTF-8 in RowBinary\n\nWhen decoding [`String`](https://clickhouse.com/docs/en/sql-reference/data-types/string) columns non UTF-8 characters are replaced with `�` (U+FFFD). This behaviour is similar to [`toValidUTF8`](https://clickhouse.com/docs/en/sql-reference/functions/string-functions#tovalidutf8) and [JSON format.](https://clickhouse.com/docs/en/interfaces/formats#json)\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE ch_utf8(str String) ENGINE Memory\")\n\nbin = \"\\x61\\xF0\\x80\\x80\\x80b\"\nutf8 = \"a�b\"\n\n%Ch.Result{num_rows: 1} =\n  Ch.query!(pid, \"INSERT INTO ch_utf8(str) FORMAT RowBinary\", [[bin]], types: [\"String\"])\n\n%Ch.Result{rows: [[^utf8]]} =\n  Ch.query!(pid, \"SELECT * FROM ch_utf8\")\n\n%Ch.Result{rows: %{\"data\" => [[^utf8]]}} =\n  pid |> Ch.query!(\"SELECT * FROM ch_utf8 FORMAT JSONCompact\") |> Map.update!(:rows, &Jason.decode!/1)\n```\n\nTo get raw binary from `String` columns use `:binary` type that skips UTF-8 checks.\n\n```elixir\n%Ch.Result{rows: [[^bin]]} =\n  Ch.query!(pid, \"SELECT * FROM ch_utf8\", [], types: [:binary])\n```\n\n#### Timezones in RowBinary\n\nDecoding non-UTC datetimes like `DateTime('Asia/Taipei')` requires a [timezone database.](https://hexdocs.pm/elixir/DateTime.html#module-time-zone-database)\n\n```elixir\nMix.install([:ch, :tz])\n\n:ok = Calendar.put_time_zone_database(Tz.TimeZoneDatabase)\n\n{:ok, pid} = Ch.start_link()\n\n%Ch.Result{rows: [[~N[2023-04-25 17:45:09]]]} =\n  Ch.query!(pid, \"SELECT CAST(now() as DateTime)\")\n\n%Ch.Result{rows: [[~U[2023-04-25 17:45:11Z]]]} =\n  Ch.query!(pid, \"SELECT CAST(now() as DateTime('UTC'))\")\n\n%Ch.Result{rows: [[%DateTime{time_zone: \"Asia/Taipei\"} = taipei]]} =\n  Ch.query!(pid, \"SELECT CAST(now() as DateTime('Asia/Taipei'))\")\n\n\"2023-04-26 01:45:12+08:00 CST Asia/Taipei\" = to_string(taipei)\n```\n\nEncoding non-UTC datetimes works but might be slow due to timezone conversion:\n\n```elixir\nMix.install([:ch, :tz])\n\n:ok = Calendar.put_time_zone_database(Tz.TimeZoneDatabase)\n\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE ch_datetimes(name String, datetime DateTime) ENGINE Memory\")\n\nnaive = NaiveDateTime.utc_now()\nutc = DateTime.utc_now()\ntaipei = DateTime.shift_zone!(utc, \"Asia/Taipei\")\n\nrows = [[\"naive\", naive], [\"utc\", utc], [\"taipei\", taipei]]\n\nCh.query!(pid, \"INSERT INTO ch_datetimes(name, datetime) FORMAT RowBinary\", rows, types: [\"String\", \"DateTime\"])\n\n%Ch.Result{\n  rows: [\n    [\"naive\", ~U[2024-12-21 05:24:40Z]],\n    [\"utc\", ~U[2024-12-21 05:24:40Z]],\n    [\"taipei\", ~U[2024-12-21 05:24:40Z]]\n  ]\n} =\n  Ch.query!(pid, \"SELECT name, CAST(datetime as DateTime('UTC')) FROM ch_datetimes\")\n```\n\n## [Benchmarks](./bench)\n\nSee nightly [CI runs](https://github.com/plausible/ch/actions/workflows/bench.yml) for latest results.","title":"Caveats - Ch","ref":"readme.html#caveats"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"- fix column decoding when count exceeds 127 https://github.com/plausible/ch/pull/257","title":"0.4.1 (2025-07-07) - Changelog","ref":"changelog.html#0-4-1-2025-07-07"},{"type":"extras","doc":"- restrict to Ecto v3.13","title":"0.4.0 (2025-06-19) - Changelog","ref":"changelog.html#0-4-0-2025-06-19"},{"type":"extras","doc":"- fix column decoding when count exceeds 127 https://github.com/plausible/ch/pull/257","title":"0.3.4 (2025-07-07) - Changelog","ref":"changelog.html#0-3-4-2025-07-07"},{"type":"extras","doc":"- restrict to Ecto v3.12","title":"0.3.3 (2025-06-19) - Changelog","ref":"changelog.html#0-3-3-2025-06-19"},{"type":"extras","doc":"- fix type decoding when type name exceeds 127 bytes https://github.com/plausible/ch/pull/248","title":"0.3.2 (2025-02-25) - Changelog","ref":"changelog.html#0-3-2-2025-02-25"},{"type":"extras","doc":"- add column names to `%Ch.Result{}` https://github.com/plausible/ch/pull/243","title":"0.3.1 (2025-02-08) - Changelog","ref":"changelog.html#0-3-1-2025-02-08"},{"type":"extras","doc":"- gracefully handle `connection: closed` response from server https://github.com/plausible/ch/pull/211\n- allow non-UTC `DateTime.t()` in query params https://github.com/plausible/ch/pull/223\n- allow non-UTC `DateTime.t()` when encoding RowBinary https://github.com/plausible/ch/pull/225\n- add `:types` to `query_option` typespec https://github.com/plausible/ch/pull/234\n- handle missing `written_rows` in insert https://github.com/plausible/ch/pull/236","title":"0.3.0 (2025-02-03) - Changelog","ref":"changelog.html#0-3-0-2025-02-03"},{"type":"extras","doc":"- handle missing `written_rows` in insert https://github.com/plausible/ch/pull/236 (backported)","title":"0.2.10 (2025-02-03) - Changelog","ref":"changelog.html#0-2-10-2025-02-03"},{"type":"extras","doc":"- catch all errors in `connect/1` to avoid triggering Supervisor https://github.com/plausible/ch/pull/209","title":"0.2.9 (2024-11-04) - Changelog","ref":"changelog.html#0-2-9-2024-11-04"},{"type":"extras","doc":"- support named tuples https://github.com/plausible/ch/pull/197","title":"0.2.8 (2024-09-06) - Changelog","ref":"changelog.html#0-2-8-2024-09-06"},{"type":"extras","doc":"- raise on invalid UInt8 and Int8 when encoding RowBinary https://github.com/plausible/ch/pull/180\n- adapt to Ecto v3.12 https://github.com/plausible/ch/pull/195","title":"0.2.7 (2024-08-15) - Changelog","ref":"changelog.html#0-2-7-2024-08-15"},{"type":"extras","doc":"- fix query encoding for datetimes where the microseconds value starts with zeroes `~U[****-**-** **:**:**.0*****]` https://github.com/plausible/ch/pull/175","title":"0.2.6 (2024-05-30) - Changelog","ref":"changelog.html#0-2-6-2024-05-30"},{"type":"extras","doc":"- add `:data` in `%Ch.Result{}` https://github.com/plausible/ch/pull/159\n- duplicate `Ch.Result.data` in `Ch.Result.rows` for backwards compatibility https://github.com/plausible/ch/pull/160\n- make `Ch.stream` emit `Ch.Result.t` instead of `Mint.Types.response` https://github.com/plausible/ch/pull/161\n- make `Ch.stream` collectable https://github.com/plausible/ch/pull/162","title":"0.2.5 (2024-03-05) - Changelog","ref":"changelog.html#0-2-5-2024-03-05"},{"type":"extras","doc":"- use `ch-#{version}` as user-agent https://github.com/plausible/ch/pull/154\n- fix query string escaping for `\\t`, `\\\\`, and `\\n` https://github.com/plausible/ch/pull/155","title":"0.2.4 (2024-01-29) - Changelog","ref":"changelog.html#0-2-4-2024-01-29"},{"type":"extras","doc":"- fix socket leak on failed handshake https://github.com/plausible/ch/pull/153","title":"0.2.3 (2024-01-29) - Changelog","ref":"changelog.html#0-2-3-2024-01-29"},{"type":"extras","doc":"- fix query encoding for datetimes with zeroed microseconds `~U[****-**-** **:**:**.000000]` https://github.com/plausible/ch/pull/138","title":"0.2.2 (2023-12-23) - Changelog","ref":"changelog.html#0-2-2-2023-12-23"},{"type":"extras","doc":"- fix array casts with `Ch` subtype https://github.com/plausible/ch/pull/118","title":"0.2.1 (2023-08-22) - Changelog","ref":"changelog.html#0-2-1-2023-08-22"},{"type":"extras","doc":"- move loading and dumping from `Ch` type to the adapter https://github.com/plausible/ch/pull/112","title":"0.2.0 (2023-07-28) - Changelog","ref":"changelog.html#0-2-0-2023-07-28"},{"type":"extras","doc":"- simplify types, again...","title":"0.1.14 (2023-05-24) - Changelog","ref":"changelog.html#0-1-14-2023-05-24"},{"type":"extras","doc":"- refactor types in `Ch.RowBinary` https://github.com/plausible/ch/pull/88","title":"0.1.13 (2023-05-24) - Changelog","ref":"changelog.html#0-1-13-2023-05-24"},{"type":"extras","doc":"- replace `{:raw, data}` with `encode: false` option, add `:decode` option https://github.com/plausible/ch/pull/42","title":"0.1.12 (2023-05-24) - Changelog","ref":"changelog.html#0-1-12-2023-05-24"},{"type":"extras","doc":"- improve Enum error message invalid values during encoding: https://github.com/plausible/ch/pull/85\n- fix `\\t` and `\\n` in query params https://github.com/plausible/ch/pull/86","title":"0.1.11 (2023-05-19) - Changelog","ref":"changelog.html#0-1-11-2023-05-19"},{"type":"extras","doc":"- support `:raw` option in `Ch` type https://github.com/plausible/ch/pull/84","title":"0.1.10 (2023-05-05) - Changelog","ref":"changelog.html#0-1-10-2023-05-05"},{"type":"extras","doc":"- relax deps versions","title":"0.1.9 (2023-05-02) - Changelog","ref":"changelog.html#0-1-9-2023-05-02"},{"type":"extras","doc":"- fix varint encoding","title":"0.1.8 (2023-05-01) - Changelog","ref":"changelog.html#0-1-8-2023-05-01"},{"type":"extras","doc":"- support RowBinaryWithNamesAndTypes","title":"0.1.7 (2023-04-24) - Changelog","ref":"changelog.html#0-1-7-2023-04-24"},{"type":"extras","doc":"- add Map(K,V) support in Ch Ecto type","title":"0.1.6 (2023-04-24) - Changelog","ref":"changelog.html#0-1-6-2023-04-24"},{"type":"extras","doc":"- fix query param encoding like Array(Date)\n- add more types support in Ch Ecto type: tuples, ipv4, ipv6, geo","title":"0.1.5 (2023-04-23) - Changelog","ref":"changelog.html#0-1-5-2023-04-23"},{"type":"extras","doc":"- actually support negative `Enum` values","title":"0.1.4 (2023-04-23) - Changelog","ref":"changelog.html#0-1-4-2023-04-23"},{"type":"extras","doc":"- support negative `Enum` values, fix `Enum16` encoding","title":"0.1.3 (2023-04-23) - Changelog","ref":"changelog.html#0-1-3-2023-04-23"},{"type":"extras","doc":"- support `Enum8` and `Enum16` encoding","title":"0.1.2 (2023-04-23) - Changelog","ref":"changelog.html#0-1-2-2023-04-23"},{"type":"extras","doc":"- cleanup published docs","title":"0.1.1 (2023-04-23) - Changelog","ref":"changelog.html#0-1-1-2023-04-23"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}